### This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import sos.plugintools


def get_partitions():
    partitions = open('/proc/partitions')
    try:
        result = []
        for entry in partitions:
            info = entry.split()
            if len(info) != 4:
               continue
            major = info[0]
            name = info[3]
            if not major.isdigit():
                continue
            if name.startswith('loop'):
                continue
            if name.startswith('dm-'):
                continue
            result.append(name)
        return result
    finally:
        partitions.close()


class smartmon(sos.plugintools.PluginBase):
    """ Dump SMART disk information.
    """
    def setup(self):
        for dev in get_partitions():
            self.collectExtOutput('/usr/sbin/smartctl --all /dev/%s' % dev)
